/** ߳ */

package com.regexlab.ftp;

import java.io.*;
import java.net.*;
import java.text.*;
import java.util.*;

public class DataThread extends Thread
{
    // ͨò
    private PrintWriter  out         = null;
    private Socket       theSocket   = null;
    public  boolean      isClosed    = false;
    public  boolean      IsKicked    = false;

    // 
    private static final int DO_NOOP = 0;
    private static final int DO_PASV = 1;
    private static final int DO_PORT = 2;
    private static final int DO_LIST = 3;
    private static final int DO_NLST = 4;
    private static final int DO_RETR = 5;
    private static final int DO_STOR = 6;
    private static final int DO_EPSV = 7;

    private int todo = DO_NOOP;

    // PASVPORT ҪĲ
    private ServerSocket lssock      = null;
    private String       ip          = null;
    private int          port        = 0;

    // LISTNLSTRETRSTOR ҪĲ
    LimitInterface  theLimiter       = null;
    AccessInterface theAccess        = null;

    // LISTNLST
    String          strDir           = null;
    String          strFilter        = null;

    // RETRSTOR
    String          strPath          = null;
    long            restOff          = 0;
    char            dataType         = 'I';

    // ٶ
    boolean         limited          = false;
    int             sleeptm          = 0;
    int             bufSize          = 10240;
    byte            buf[]            = new byte[bufSize];
    boolean         bufChanged       = true;

    static int serial = 1;
    
    /** 캯
     *  @param pw ߳ */
    public DataThread(LimitInterface Limiter, PrintWriter pw, ThreadGroup group){
        super(group, "DataThread-"+serial++);
        
        theLimiter = Limiter;
        theAccess  = Limiter.getAccess();
        out        = pw;
        
        this.setDaemon(true);
    }

    /**  */
    public void PASV(String localIP)
    {
        ip = localIP;

        todo = DO_PASV;
        start();
    }

    public void EPSV(String localIP)
    {
        ip = localIP;

        todo = DO_EPSV;
        start();
    }

    /**  */
    public void PORT(String param)
    {
        param   = param.replace(',', ' ');
        ip      = Tools.SubStr(param, 1) + "." + Tools.SubStr(param, 2) + "." + Tools.SubStr(param, 3) + "." + Tools.SubStr(param, 4);
        port    = Integer.parseInt(Tools.SubStr(param, 5)) * 256 + Integer.parseInt(Tools.SubStr(param, 6));

        todo = DO_PORT;
        start();
    }
    
    public void EPRT(String param)
    {
        String [] ps = param.split("\\|");
        ip = ps[2];
        port = Integer.parseInt(ps[3]);
        
        todo = DO_PORT;
        start();
    }

    /** Ŀ¼ */
    public void LIST(String dir, String filter)
    {
        strDir    = dir;
        strFilter = filter;

        todo = DO_LIST;
        interrupt();
    }

    /** Ŀ¼ļ */
    public void NLST(String dir, String filter)
    {
        strDir    = dir;
        strFilter = filter;

        todo = DO_NLST;
        interrupt();
    }

    public void RETR(String Path, long Off, char Type)
    {
        strPath    = Path;
        restOff    = Off;
        dataType   = Type;

        todo = DO_RETR;
        interrupt();
    }

    public void STOR(String Path, long Off, char Type)
    {
        strPath    = Path;
        restOff    = Off;
        dataType   = Type;

        todo = DO_STOR;
        interrupt();
    }

    // ִ߳
    public void run()
    {
        int localPort;
        
        switch(todo)
        {
        case DO_PASV:
            // 
            try{
                lssock = new ServerSocket(0);
            }catch(IOException ioe){
                out.println("500 Pasv failed.");
                return;
            }

            // Ϣ
            localPort       = lssock.getLocalPort();
            out.println("227 (" + ip.replace('.', ',') + "," + String.valueOf(localPort/256) + "," + String.valueOf(localPort%256) + ") Pasv succeeded.");

            // 
            try{
                lssock.setSoTimeout(30000); // ȴ30
                theSocket = lssock.accept();
            }catch(Exception e){
                out.println("425 Pasv failed");
                close();
                return;
            }
            // ֹͣ
            try{
                lssock.close();
            }catch(IOException e){}
            lssock = null;
            break;
            
        case DO_EPSV:
            // 
            try{
                lssock = new ServerSocket(0);
            }catch(IOException ioe){
                out.println("500 Pasv failed.");
                return;
            }

            // Ϣ
            localPort       = lssock.getLocalPort();
            out.println("229 Extended Passive mode OK (|||" + String.valueOf(localPort) + "|)");

            // 
            try{
                lssock.setSoTimeout(30000); // ȴ30
                theSocket = lssock.accept();
            }catch(Exception e){
                out.println("425 Pasv failed");
                close();
                return;
            }
            // ֹͣ
            try{
                lssock.close();
            }catch(IOException e){}
            lssock = null;
            break;

        case DO_PORT:
            // 
            try{
                theSocket = new Socket(ip, port);
                out.println("200 Port succeeded"); // ɹ
            }catch(IOException e){
                System.out.println("PORT Error: "+e);
                out.println("425 Port failed");
                close();
                return;
            }
            break;

        default:
            close();
            return;
        }

        // ӳɹȴinterrupt
        try{
            sleep(30000);
        }catch(InterruptedException e){}

        switch(todo)
        {
        case DO_LIST:
            try
            {
                out.println("150 Ready to List Directory of \""+strDir+strFilter+"\"");
                PrintWriter aout = new PrintWriter(theSocket.getOutputStream(),true);

                // Ȩ޼
                if(!theAccess.getAccessPermission(strDir, AccessInterface.OPER_LIST)){
                    aout.close();
                    out.println("226 List Directory of \""+strDir+"\" not permitted.");
                    break;
                }

                String strAbsDir = theAccess.getAbsolutePath(strDir);
                File        d    = new File(strAbsDir);
                ListFilter  fltr = null;

                File FileList[];
                if(strFilter.length()>0){
                    fltr = new ListFilter(strFilter);
                    FileList = d.listFiles(fltr);
                }else
                    FileList = d.listFiles();

                Calendar cal = Calendar.getInstance();
                int thisYear = cal.get(Calendar.YEAR);
                SimpleDateFormat forThisYear = new SimpleDateFormat ("MMM dd HH:mm", Locale.US);
                SimpleDateFormat forLastYear = new SimpleDateFormat ("MMM dd  yyyy", Locale.US);

                for(int i=0;i<FileList.length;i++)
                {
                    File f  = FileList[i];
                    if(f.isHidden())
                        continue;

                    Date fileDate = new Date(f.lastModified());
                    cal.setTime(fileDate);
                    String ftime = null;
                    if(cal.get(Calendar.YEAR)==thisYear)
                        ftime = forThisYear.format(fileDate);
                    else
                        ftime = forLastYear.format(fileDate);

                    if(f.isDirectory()){
                        aout.println("drwxr-xr-- 1 user user " + Tools.right("            " + String.valueOf(f.length()),12) + " " + ftime + " " + f.getName());
                    }else{
                        aout.println("-rwxr-xr-- 1 user user " + Tools.right("            " + String.valueOf(f.length()),12) + " " + ftime + " " + f.getName());
                    }
                }

                aout.print(theAccess.LISTV(strDir, fltr));
                aout.close();

                out.println("226 List finished.");

            }catch(Exception e){
                if(isClosed)
                    out.println("426 List failed.");
                else
                    out.println("500 List failed.");
            }finally{
                try{
                    theSocket.close();
                }catch(Exception e){};
                theSocket = null;
            }
            break;

        case DO_NLST:
            try
            {
                out.println("150 Ready to NList Directory of \""+strDir+strFilter+"\"");
                PrintWriter aout = new PrintWriter(theSocket.getOutputStream(),true);

                // Ȩ޼
                if(!theAccess.getAccessPermission(strDir, AccessInterface.OPER_LIST)){
                    aout.close();
                    out.println("226 NList Directory of \""+strDir+"\" not permitted.");
                    break;
                }

                String strAbsDir = theAccess.getAbsolutePath(strDir);
                File        d    = new File(strAbsDir);
                ListFilter  fltr = null;

                File FileList[];
                if(strFilter.length()>0){
                    fltr = new ListFilter(strFilter);
                    FileList = d.listFiles(fltr);
                }else
                    FileList = d.listFiles();

                for(int i=0;i<FileList.length;i++){
                    if(!FileList[i].isHidden())
                        aout.println(FileList[i].getName());
                }

                aout.print(theAccess.NLSTV(strDir, fltr));
                aout.close();

                out.println("226 NList finished.");

            }catch(Exception e){
                if(isClosed)
                    out.println("426 NList failed.");
                else
                    out.println("500 NList failed.");
            }finally{
                try{
                    theSocket.close();
                }catch(Exception e){}
                theSocket = null;
            }
            break;

        case DO_RETR:
            try
            {
                OutputStream oout = theSocket.getOutputStream();

                // Ȩ޼
                if(!theAccess.getAccessPermission(strPath, AccessInterface.OPER_DOWNLOAD)){
                    oout.close();
                    out.println("450 Download \""+strPath+"\" not permitted.");
                    break;
                }

                out.println("150 Ready to download.");

                // ֧ı REST
                if(restOff>0)
                    dataType = 'I';

                // ٶ
                setSpeed(theAccess.getDownloadSpeedLimit(strPath));

                if(dataType == 'I'){
                    // ļ
                    BufferedInputStream  iin  = new BufferedInputStream(new FileInputStream(theAccess.getAbsolutePath(strPath)));
                    // Socket 
                    BufferedOutputStream iout = new BufferedOutputStream(oout);

                    // REST
                    if(restOff>0)
                        iin.skip(restOff);

                    byte b[] = null;
                    while(true)
                    {
                        // Ϊ˶̬ٶ
                        if(bufChanged){
                            b = buf;
                            bufChanged = false;
                        }

                        int red = iin.read(b);
                        if(red<0)
                            break;
                        iout.write(b, 0, red);

                        // ٶ
                        if(limited){
                            if(IsKicked)
                                throw new Exception("Been Kicked");
                            sleep(sleeptm);
                        }
                    }
                    iout.close();
                    iin.close();
                }else{
                    // ļı
                    BufferedReader  ain = new BufferedReader(new InputStreamReader(new FileInputStream(theAccess.getAbsolutePath(strPath))));
                    // Socket ı
                    PrintStream  aout = new PrintStream(new BufferedOutputStream(oout), true);

                    int    cntr  = 0;
                    String aline = null;
                    while(true)
                    {
                        aline = ain.readLine();

                        if(aline == null)
                            break;
                        aout.print(aline);
                        aout.print("\r\n");

                        // ٶ
                        if(limited){
                            if(IsKicked)
                                throw new Exception("Been Kicked");
                            cntr += aline.length();
                            if(cntr>=bufSize){
                                cntr -= bufSize;
                                sleep(sleeptm);
                            }
                        }
                    }
                    aout.close();
                    ain.close();//*/
                }
                out.println("226 Download succeeded.");

            }catch(Exception e){
                if(isClosed)
                    out.println("426 Download failed.");
                else
                    out.println("550 Download failed.");
            }finally{
                try{
                    theSocket.close();
                }catch(Exception e){}
                theSocket = null;
            }
            break;

        case DO_STOR:
            try
            {
                InputStream oin = theSocket.getInputStream();
                strDir          = strPath.substring(0, strPath.lastIndexOf('/')+1);

                // Ȩ޼
                if(!theAccess.getAccessPermission(strPath, AccessInterface.OPER_UPLOAD)){
                    oin.close();
                    out.println("450 Upload to \""+strDir+"\" not permitted.");
                    break;
                }

                boolean limitSpace = theAccess.getSpaceLimit(strDir)>0;
                long    spaceFree  = theAccess.getSpaceFree(strDir);
                long    spaceSumr  = 0;

                // ޿ռ
                if(limitSpace && spaceFree<=0)
                {
                    oin.close();
                    out.println("450 No space free in Directory of \""+strDir+"\"");
                    break;
                }

                String     strAbsPath = theAccess.getAbsolutePath(strPath);
                File       f          = new File(strAbsPath);
                FileOutputStream oout = null;

                // REST
                if(restOff>0){
                    dataType = 'I';
                    if(f.exists() && f.length()==restOff)
                        oout = new FileOutputStream(strAbsPath, true);
                    else{
                        // ֻܴӶϵ
                        oin.close();
                        out.println("450-Restart uploading Error");
                        out.println("450 Multi-line Upload NOT supported.");
                        break;
                    }
                }else{
                    if(!f.exists() || theAccess.getAccessPermission(strPath, AccessInterface.OPER_DELETE))
                        oout = new FileOutputStream(strAbsPath);
                    else{
                        // Ըļ
                        oin.close();
                        out.println("450 Overwrite an Existing File Not Permitted.");
                        break;
                    }
                }

                out.println("150 Ready to upload.");

                // ٶ
                setSpeed(theAccess.getUploadSpeedLimit(strPath));

                try // Ϊ˿ռռtry,finally
                {
                    if(dataType == 'I'){
                        // ļ
                        BufferedInputStream  iin  = new BufferedInputStream(oin);
                        // Socket 
                        BufferedOutputStream iout = new BufferedOutputStream(oout);

                        byte b[] = null;
                        while(true)
                        {
                            // Ϊ˶̬ٶ
                            if(bufChanged){
                                b = buf;
                                bufChanged = false;
                            }

                            int red = iin.read(b);
                            if(red<0)
                                break;
                            iout.write(b, 0, red);

                            // ٶ
                            if(limited){
                                if(IsKicked)
                                    throw new Exception("Been Kicked");
                                sleep(sleeptm);
                            }
                            // ռ
                            if(limitSpace){
                                spaceSumr += red;
                                if(spaceSumr>spaceFree)
                                {
                                    iout.close();
                                    oout.close();
                                    f.delete();
                                    out.println("550-No Enough Space.");
                                    throw new Exception("No enough space.");
                                }
                            }
                        }
                        iout.close();
                        iin.close();
                    }else{
                        // ļı
                        BufferedReader ain  = new BufferedReader(new InputStreamReader(oin));
                        // Socket ı
                        PrintStream    aout = new PrintStream(new BufferedOutputStream(oout), true);

                        int    cntr  = 0;
                        String aline = null;
                        while(true)
                        {
                            aline = ain.readLine();

                            if(aline == null)
                                break;
                            aout.print(aline);
                            aout.print("\r\n");

                            // ٶ
                            if(limited){
                                if(IsKicked)
                                    throw new Exception("Been Kicked");
                                cntr += aline.length();
                                if(cntr>=bufSize){
                                    cntr -= bufSize;
                                    sleep(sleeptm);
                                }
                            }
                            // ռ
                            if(limitSpace){
                                spaceSumr += aline.length();
                                if(spaceSumr>spaceFree)
                                {
                                    aout.close();
                                    oout.close();
                                    f.delete();
                                    out.println("550-No Enough Space.");
                                    throw new Exception("No enough space.");
                                }
                            }
                        }
                        aout.close();
                        ain.close();//*/
                    }
                }finally{ // ռ仯
                    if(f.exists())
                        theAccess.setUseSpace(strDir, f.length()-restOff);
                    else
                        theAccess.setUseSpace(strDir, -restOff);
                }

                out.println("226 Upload succeeded.");

            }catch(Exception e){
                if(isClosed)
                    out.println("426 Upload failed.");
                else
                    out.println("550 Upload failed.");
            }finally{
                try{
                    theSocket.close();
                }catch(Exception e){}
                theSocket = null;
            }
            break;

        default:
            out.println("500 Error");
        case DO_NOOP:
            System.out.println("One DataThread Done Nothing.");
            break;
        }

        // 
        close();
    }

    /** رգϿ */
    public void close()
    {
        isClosed = true;

        // жϹ
        todo = DO_NOOP;
        interrupt();

        // ǿйر
        if(lssock!=null){
            try{
                lssock.close();
            }catch(IOException e){}
            lssock = null;
        }

        // ǿйر
        if(theSocket!=null){
            try{
                theSocket.close();
            }catch(IOException e){}
            theSocket = null;
        }
    }

    /** 趨ļٶȣλֽڣ */
    public void setSpeed(long speed)
    {
        limited = (0<speed) && (speed<=500*1024);
        bufSize = 10240;
        if(limited){
            if(speed<1024) // ٶ1K
                speed  =1024;
            bufSize    = (int)(speed/1024/10*1024)+1024;
            sleeptm    = (int)(bufSize*1000.0/speed);
        }
        buf        = new byte[bufSize];
        bufChanged = true;
    }
}
