/**
 * FTP߳
 */

package com.regexlab.ftp;

import java.io.*;
import java.net.*;

public class FtpThread extends Thread
{
    /** FtpʵSocket */
    Socket           theSocket      = null;
    /** ¼ */
    LimitInterface   theLimiter     = null;
    /** Ȩ޿ */
    AccessInterface  theAccess      = null;

    boolean Running          = true;
    boolean IsKicked         = false;

    /** һļ䷽ʽ'A''I' */
    char       dataType      = 'I';
    /** ߳ */
    DataThread theDataThread = null;
    /**  */
    long       restOff       = 0;

    /**  */
    String    nextline = null;
    /** ߳ */
    BufferedReader in  = null;
    /** ߳ */
    PrintWriter    out = null;

    /** ¼û */
    String userName    = "Anonymous";
    /** ¼ */
    String userPwd     = "";
    /** ǰĿ¼ */
    String currDir     = "/";
    
    ThreadGroup group  = null;
    
    static int serial = 1;

    /** 캯
     *  @param sckt 
     *  @param lmt ¼ */
    public FtpThread(Socket sckt, ThreadGroup group){
        super(group, "FtpThread-"+serial++);
        this.group = group;
        theSocket  = sckt;
        this.setDaemon(true);
    }

    public void run()
    {
        String  cmd       = null;
        String  param     = null;
        String  strPath   = null;
        String  renfrom   = null;
        boolean loginSucc = false;

        try{
            in  = new BufferedReader(new InputStreamReader(theSocket.getInputStream()));
            out = new PrintWriter   (theSocket.getOutputStream(),true);

            // ӳɹϢ
            out.println("220 Welcome to MyLove Ftp Service");
            System.out.println("Connected from "+theSocket.getInetAddress().getHostAddress());

            while(Running)
            {
                // ȡ
                try{
                    nextline=in.readLine();
                    if(nextline==null)break;
                }catch(Exception excpt){
                    System.out.println("Forced to close: "+excpt);
                    break;
                }

                // ߳
                if(IsKicked){
                    out.println("221 "+theLimiter.getReason());
                    break;
                }

                // ֽͲ
                System.out.println(nextline);
                cmd     = Tools.SubStr(nextline, 1);
                param   = nextline.substring(Tools.SubStrPos(nextline, 2));

                // û ----------------------------------------
                if(cmd.equalsIgnoreCase("USER"))
                {
                    userName = param;
                    loginSucc = theLimiter.Login(userName, userPwd, theSocket.getInetAddress().getHostAddress());

                    if(loginSucc){ // ¼ɹ
                        theAccess = theLimiter.getAccess();
                        out.println("230 Login Success!");
                    }else{
                        out.println("331 "+theLimiter.getReason());
                    }
                }

                //  ----------------------------------------
                else if(cmd.equalsIgnoreCase("PASS"))
                {
                    userPwd = param;
                    loginSucc = theLimiter.Login(userName, userPwd, theSocket.getInetAddress().getHostAddress());

                    if(loginSucc){
                        theAccess = theLimiter.getAccess();
                        out.println("230 Login Success!");
                    }else{
                        out.println("530 "+theLimiter.getReason());
                    }
                }

                // ˳ ----------------------------------------
                else if(cmd.equalsIgnoreCase("QUIT")){
                    out.println("221 Good bye!"); // ׼ر
                    Running = false;
                }

                // ϵͳϢ ----------------------------------------
                else if(cmd.equalsIgnoreCase("SYST")){
                    out.println("215 Unix Type: L8");
                }

                //
                else if(cmd.equalsIgnoreCase("PASV")){
                    if(theDataThread!=null)
                        theDataThread.close();
                    theDataThread = new DataThread(theLimiter, out, group);
                    theDataThread.PASV(theSocket.getLocalAddress().getHostAddress());
                }

                //
                else if(cmd.equalsIgnoreCase("EPSV")){
                    if(theDataThread!=null)
                        theDataThread.close();
                    theDataThread = new DataThread(theLimiter, out, group);
                    theDataThread.EPSV(theSocket.getLocalAddress().getHostAddress());
                }

                //
                else if(cmd.equalsIgnoreCase("PORT")){
                    if(theDataThread!=null)
                        theDataThread.close();
                    theDataThread = new DataThread(theLimiter, out, group);
                    theDataThread.PORT(param);
                }

                else if(cmd.equalsIgnoreCase("EPRT")){
                    if(theDataThread!=null)
                        theDataThread.close();
                    theDataThread = new DataThread(theLimiter, out, group);
                    theDataThread.EPRT(param);
                }
                
                ////////////////////////////////////////////////////

                else if(!loginSucc){
                    out.println("530 Login first");
                }

                //
                else if(cmd.equalsIgnoreCase("CWD")){
                    String tmpDir = Tools.fmtPath(currDir, param+"/");
                    File d = new File(theAccess.getAbsolutePath(tmpDir));
                    if(d.exists() && d.isDirectory()){
                        currDir = tmpDir;
                        out.println("250 \""+currDir+"\" is current directory.");
                    }else
                        out.println("500 No such directory.");
                }

                //
                else if(cmd.equalsIgnoreCase("LIST")){
                    if(param.equals("-aL") || param.equals("-a") || param.equals("-L")) param = "";
                    strPath  = Tools.fmtPath(currDir, param);
                    //dataType = 'A';
                    int pd = strPath.lastIndexOf('/');
                    if(theDataThread==null)
                        out.println("450 PASV or PORT first.");
                    else if(theDataThread.isClosed)
                        out.println("450 PASV or PORT first.");
                    else
                        theDataThread.LIST(strPath.substring(0, pd+1), strPath.substring(pd+1));
                }

                //
                else if(cmd.equalsIgnoreCase("TYPE")){
                    char Type = Character.toUpperCase((param+' ').charAt(0));
                    if(Type=='A'|| Type=='I'){
                        dataType = Type;
                        out.println("200 Set type to " + param);
                    }else
                        out.println("504 Type "+Type+" NOT supported");
                }

                //
                else if(cmd.equalsIgnoreCase("RETR")){
                    strPath = Tools.fmtPath(currDir, param);
                    if(theDataThread==null)
                        out.println("450 PASV or PORT first.");
                    else if(theDataThread.isClosed)
                        out.println("450 PASV or PORT first.");
                    else
                        theDataThread.RETR(strPath, restOff, dataType);
                    restOff = 0;
                }

                //
                else if(cmd.equalsIgnoreCase("STOR")){
                    strPath = Tools.fmtPath(currDir, param);
                    if(theDataThread==null)
                        out.println("450 PASV or PORT first.");
                    else if(theDataThread.isClosed)
                        out.println("450 PASV or PORT first.");
                    else
                        theDataThread.STOR(strPath, restOff, dataType);
                    restOff = 0;
                }

                //
                else if(cmd.equalsIgnoreCase("REST")){
                    restOff = Long.parseLong("0"+param);
                    out.println("350 Restart from "+param+" OK");
                }

                //
                else if(cmd.equalsIgnoreCase("SIZE")){
                    strPath = Tools.fmtPath(currDir, param);
                    File f = new File(theAccess.getAbsolutePath(strPath));
                    if(f.exists() && f.isFile())
                        out.println("213 "+String.valueOf(f.length()));
                    else
                        out.println("500 No such file.");
                }

                //
                else if(cmd.equalsIgnoreCase("NLST")){
                    strPath  = Tools.fmtPath(currDir, param);
                    //dataType = 'A';
                    int pd = strPath.lastIndexOf('/');
                    if(theDataThread==null)
                        out.println("450 PASV or PORT first.");
                    else if(theDataThread.isClosed)
                        out.println("450 PASV or PORT first.");
                    else
                        theDataThread.NLST(strPath.substring(0, pd+1), strPath.substring(pd+1));
                }

                // ǰĿ¼ ----------------------------------------
                else if(cmd.equalsIgnoreCase("PWD") || cmd.equalsIgnoreCase("XPWD")){
                    out.println("257 \"" + currDir + "\" is current directory.");
                }

                //
                else if(cmd.equalsIgnoreCase("ABOR") || Tools.right(cmd, 3).equalsIgnoreCase("BOR")){
                    if(theDataThread!=null){
                        theDataThread.close();
                        theDataThread = null;
                        sleep(10);
                    }
                    out.println("226 Aborted.");
                }

                //
                else if(cmd.equalsIgnoreCase("DELE")){
                    strPath = Tools.fmtPath(currDir, param);
                    if(theAccess.getAccessPermission(strPath, AccessInterface.OPER_DELETE) && !theAccess.isVirtualNode(strPath))
                    {
                        File f     = new File(theAccess.getAbsolutePath(strPath));
                        long fsize = f.length();
                        if(!f.exists() || f.isDirectory())
                            out.println("550 No such file \""+strPath+"\"");
                        else if(!f.delete())
                            out.println("550 Delete \""+strPath+"\" failed.");
                        else{
                            theAccess.setUseSpace(strPath, -fsize);
                            out.println("250 Delete succeeded.");
                        }
                    }else
                        out.println("450 Delete \""+strPath+"\" not permitted.");
                }

                //
                else if(cmd.equalsIgnoreCase("RNFR")){
                    strPath = Tools.fmtPath(currDir, param);
                    renfrom = null;
                    if(theAccess.getAccessPermission(strPath, AccessInterface.OPER_RENAME) && !theAccess.isVirtualNode(strPath))
                    {
                        String strAbsPath = theAccess.getAbsolutePath(strPath);
                        File f = new File(strAbsPath);
                        if(f.exists()){
                            out.println("350 OK");
                            renfrom = strAbsPath;
                        }else
                            out.println("500 No such File or Directory of \""+strPath+"\"");
                    }else
                        out.println("450 Rename \""+strPath+"\" not permitted.");
                }

                //
                else if(cmd.equalsIgnoreCase("RNTO")){
                    strPath = Tools.fmtPath(currDir, param);
                    if(renfrom == null)
                        out.println("500 RNFR First.");
                    else{
                        String strAbsPath = theAccess.getAbsolutePath(strPath);
                        File f = new File(strAbsPath);
                        if(f.exists())
                            out.println("553 \""+strPath+"\" already exists.");
                        else{
                            File ffrom = new File(renfrom);
                            if(ffrom.renameTo(f))
                                out.println("250 Rename succeeded.");
                            else
                                out.println("553 Rename to \""+strPath+"\" failed.");
                        }
                    }
                }

                //
                else if(cmd.equalsIgnoreCase("MKD") || cmd.equalsIgnoreCase("XMKD")){
                    strPath = Tools.fmtPath(currDir, param);
                    if(theAccess.getAccessPermission(strPath, AccessInterface.OPER_MKDIR))
                    {
                        File d = new File(theAccess.getAbsolutePath(strPath));
                        if(d.exists())
                            out.println("550 \""+strPath+"\" already exists.");
                        else{
                            if(d.mkdir())
                                out.println("257 MkDir succeeded.");
                            else
                                out.println("550 MkDir failed.");
                        }
                    }else
                        out.println("450 MkDir \""+strPath+"\" not permitted.");
                }

                //
                else if(cmd.equalsIgnoreCase("RMD") || cmd.equalsIgnoreCase("XRMD")){
                    strPath = Tools.fmtPath(currDir, param);
                    if(theAccess.getAccessPermission(strPath, AccessInterface.OPER_RMDIR))
                    {
                        File d = new File(theAccess.getAbsolutePath(strPath));
                        if(!d.exists() || !d.isDirectory())
                            out.println("500 No such directory.");
                        else{
                            if(d.delete())
                                out.println("250 Delete succeeded.");
                            else
                                out.println("550 Delete failed.");
                        }
                    }else
                        out.println("450 Rmdir \""+strPath+"\" not permitted.");
                }

                //--- ģʽ -----------------------------------------
                else if(cmd.equalsIgnoreCase("MODE")){
                    if(Character.toUpperCase((param+' ').charAt(0)) == 'S')
                        out.println("200 Mode 'S' OK");
                    else
                        out.println("504 Mode '"+param+"'Not supported");
                }

                //
                else if(cmd.equalsIgnoreCase("STRU")){
                    if(Character.toUpperCase((param+' ').charAt(0)) == 'F')
                        out.println("200 Stru 'F' OK");
                    else
                        out.println("504 Stru '"+param+"' Not supported");
                }

                //
                else if(cmd.equalsIgnoreCase("NOOP")){
                    out.println("200 NOOP");
                }

                // //
                // else if(cmd.equalsIgnoreCase("")){
                // }

                // ʵ֣
                // USER, QUIT, PORT, TYPE, MODE, STRU, RETR, STOR, NOOP.
                // PASV, CMD , PWD , LIST, SYST, PASS, NLST
                // RNFR, RNTO, MKD , RMD , DELE, REST

                // δʵ
                else out.println("502 Command " + cmd + " not understood");
            }

            // ر
            in.close();
            out.close();

        }catch(NullPointerException nulle){
            try{
                if(in!=null)in.close();
                if(out!=null)out.close();
            }catch(IOException ioe){}
        }catch(Exception e){
            System.out.println(e);
        }finally{
            close();
            System.out.println("Disconnected.");
        }
    }

    /** ر߳ */
    public void close()
    {
        // ر߳
        if(theDataThread!=null){
            theDataThread.close();
            theDataThread = null;
        }

        // رӲϿ
        try{
            in.close();
            theSocket.close();
            theSocket = null;
        }catch(Exception e){}

        // ֹͣѭ
        Running  = false;

        // ϿȨ޿Ƶ
        theAccess = null;

        // رƲϿ
        if(theLimiter!=null){
            theLimiter.close();
            theLimiter = null;
        }
    }
}
